RTADVD.CONF(5)

NAME
rtadvd.conf - config file for router advertisement daemon

DESCRIPTION
This file describes how the router advertisement packets must be constructed for each of the interfaces.

As described in rtadvd(8), you do not have to set this configuration file up at all, unless you need some special configurations. You may even omit the file as a whole. In such cases, the rtadvd daemon will automatically configure itself using default values specified in the specification.

It obeys the famous termcap(5) file format. Each line in the file describes a network interface. Fields are separated by a colon (‘’):, and each field contains one capability description. Lines may be concatenated by the ‘\’ character. The comment marker is the ‘#’ character.

CAPABILITIES
Capabilities describe the value to be filled into ICMPv6 router advertisement messages and to control rtadvd(8) behavior. Therefore, you are encouraged to read IETF neighbor discovery documents if you would like to modify the sample configuration file.

Note that almost all items have default values. If you omit an item, the default value of the item will be used.

There are two items which control the interval of sending router advertisements. These items can be omitted, then rtadvd will use the default values.

maxinterval
    (num) The maximum time allowed between sending unsolicited multicast router advertisements (unit: seconds). The default value is 600. Its value must be no less than 4 seconds and no greater than 1800 seconds.

mininterval
    (num) The minimum time allowed between sending unsolicited multicast router advertisements (unit: seconds). The default value is the one third of value of maxinterval. Its value must be no less than 3 seconds and no greater than .75 * the value of maxinterval.

The following items are for ICMPv6 router advertisement message header. These items can be omitted, then rtadvd will use the default values.

chlim
    (num) The value for Cur Hop Limit field. The default value is 64.

raflags
    (str or num) A 8-bit flags field in router advertisement message header. This field can be specified either as a case-sensitive string or as an integer. A string consists of characters each of which corresponds to a particular flag bit(s). An integer should be the logical OR of all enabled bits. Bit 7 ( 'm' or 0x80) means Managed address configuration flag bit, and Bit 6 ( 'o' or 0x40) means Other stateful configuration flag bit. Bit 4 ( 0x10) and Bit 3 ( 0x08) are used to encode router preference. Bits 01 ( or 'h') means high, 00 means medium, and 11 ( or 'l') means low. Bits 10 is reserved, and must not be specified. There is no character to specify the medium preference explicitly. The default value of the entire flag is 0 ( or a null string,) which means no additional configuration methods, and the medium router preference.

rltime
    (num) Router lifetime field (unit: seconds). The value must be either zero or between the value of maxinterval and 9000. When rtadvd runs on a host, this value must explicitly set 0 on all the advertising interfaces as described in rtadvd(8). The default value is 1800.

rtime
    (num) Reachable time field (unit: milliseconds). The default value is 0, which means unspecified by this router.

retrans
    (num) Retrans Timer field (unit: milliseconds). The default value is 0, which means unspecified by this router.

The following items are for ICMPv6 prefix information option, which will be attached to router advertisement header. These items can be omitted, then rtadvd will automatically get appropriate prefixes from the kernel's routing table, and advertise the prefixes with the default parameters. Keywords other than clockskew and noifprefix can be augmented with a number, like “prefix2”, to specify multiple prefixes.

noifprefix
    (bool) Specifies no prefix on the network interfaces will be advertised. By default rtadvd automatically gathers on-link prefixes from all of the network interfaces and advertise them. The noifprefix disables that behavior. If this is specified and no addr keyword is specified, no prefix information option will be included in the message.

clockskew
    (num) Time skew to adjust link propagation delays and clock skews between routers on the link (unit: seconds). This value is used in consistency check for locally-configured and advertised prefix lifetimes, and has its meaning when the local router configures a prefix on the link with a lifetime that decrements in real time. If the value is 0, it means the consistency check will be skipped for such prefixes. The default value is 0.

prefixlen
    (num) Prefix length field. The default value is 64.

pinfoflags
    (str or num) A 8-bit flags field in prefix information option. This field can be specified either as a case-sensitive string or as an integer. A string consists of characters each of which corresponds to a particular flag bit(s). An integer should be the logical OR of all enabled bits. Bit 7 ( 'l' or 0x80) means On-link flag bit, and Bit 6 ( 'a' or 0x40) means Autonomous address-configuration flag bit. The default value is "la" or 0xc0, i.e., both bits are set.

addr
    (str) The address filled into Prefix field. Since “”: is used for termcap(5) file format as well as IPv6 numeric address, the field MUST be quoted by doublequote character.

vltime
    (num) Valid lifetime field (unit: seconds). The default value is 2592000 (30 days).

vltimedecr
    (bool) This item means the advertised valid lifetime will decrement in real time, which is disabled by default.

pltime
    (num) Preferred lifetime field (unit: seconds). The default value is 604800 (7 days).

pltimedecr
    (bool) This item means the advertised preferred lifetime will decrement in real time, which is disabled by default.

The following item is for ICMPv6 MTU option, which will be attached to router advertisement header. This item can be omitted, then rtadvd will use the default value.

mtu (num or str) MTU (maximum transmission unit) field. If 0 is specified, it means that the option will not be included. The default value is 0. If the special string “auto” is specified for this item, MTU option will be included and its value will be set to the interface MTU automatically.

The following item controls ICMPv6 source link-layer address option, which will be attached to router advertisement header. As noted above, you can just omit the item, then rtadvd will use the default value.

nolladdr
    (bool) By default ( if nolladdr is not specified), rtadvd(8) will try to get link-layer address for the interface from the kernel, and attach that in source link-layer address option. If this capability exists, rtadvd(8) will not attach source link-layer address option to router advertisement packets.

The following item controls ICMPv6 home agent information option, which was defined with mobile IPv6 support. It will be attached to router advertisement header just like other options do.

hapref
    (num) Specifies home agent preference. If set to non-zero, hatime must be present as well.

hatime
    (num) Specifies home agent lifetime.

When mobile IPv6 support is turned on for rtadvd(8), advertisement interval option will be attached to router advertisement packet, by configuring maxinterval explicitly.

The following items are for ICMPv6 route information option, which will be attached to router advertisement header. These items are optional. Each items can be augmented with number, like “rtplen2”, to specify multiple routes.

rtprefix
    (str) The prefix filled into the Prefix field of route information option. Since “”: is used for termcap(5) file format as well as IPv6 numeric address, the field MUST be quoted by doublequote character.

rtplen
    (num) Prefix length field in route information option. The default value is 64.

rtflags
    (str or num) A 8-bit flags field in route information option. Currently only the preference values are defined. The notation is same as that of the raflags field. Bit 4 ( 0x10) and Bit 3 ( 0x08) are used to encode the route preference for the route. The default value is 0x00, i.e., medium preference.

rtltime
    (num) route lifetime field in route information option. (unit: seconds). Since the specification does not define the default value of this item, the value for this item should be specified by hand. However, rtadvd allows this item to be unspecified, and uses the router lifetime as the default value in such a case, just for compatibility with an old version of the program.

In the above list, each keyword beginning with “rt” could be replaced with the one beginning with “rtr” for backward compatibility reason. For example, rtrplen is accepted instead of rtplen. However, keywords that start with “rtr” have basically been obsoleted, and should not be used any more.

The following items are for ICMPv6 Recursive DNS Server Option and DNS Search List Option (RFC 6106), which will be attached to router advertisement header. These items are optional.

rdnss
    (str) The IPv6 address of one or more recursive DNS servers. The argument must be inside double quotes. Multiple DNS servers can be specified in a comma-separated string. If different lifetimes are needed for different servers, separate entries can be given by using rdnss, rdnss0, rdnss1, rdnss2 ... options with corresponding rdnssltime, rdnssltime0, rdnssltime1, rdnssltime2 ... entries. Note that the maximum number of servers depends on the receiver side. See also resolver(5) manual page for resolver implementation in FreeBSD.

rdnssltime
    The lifetime of the rdnss DNS server entries. The default value is 3/2 of the interval time.

dnssl
    (str) One or more domain names in a comma-separated string. These domain names will be used when making DNS queries on a non-fully-qualified domain name. If different lifetimes are needed for different domains, separate entries can be given by using dnssl, dnssl0, dnssl1, dnssl2 ... options with corresponding dnsslltime, dnsslltime0, dnsslltime1, dnsslltime2 ... entries. Note that the maximum number of names depends on the receiver side. See also resolver(5) manual page for resolver implementation in FreeBSD.

dnsslltime
    The lifetime of the dnssl DNS search list entries. The default value is 3/2 of the interval time.

You can also refer one line from another by using tc capability. See termcap(5) for details on the capability.

EXAMPLES
As presented above, all of the advertised parameters have default values defined in specifications, and hence you usually do not have to set them by hand, unless you need special non-default values. It can cause interoperability problem if you use an ill-configured parameter.

To override a configuration parameter, you can specify the parameter alone. With the following configuration, rtadvd(8) overrides the router lifetime parameter for the ne0 interface.

    ne0:\
    	:rltime#0:

The following example manually configures prefixes advertised from the ef0 interface. The configuration must be used with the -s option to rtadvd(8).

    ef0:\
    	:addr="2001:db8:ffff:1000::":prefixlen#64:

The following example configures the wlan0 interface and adds two DNS servers and a DNS domain search options using the default option lifetime values.

    wlan0:\
    	:addr="2001:db8:ffff:1000::":prefixlen#64:\
    	:rdnss="2001:db8:ffff::10,2001:db8:ffff::2:43":\
    	:dnssl="example.com":

The following example presents the default values in an explicit manner. The configuration is provided just for reference purposes; YOU DO NOT NEED TO HAVE IT AT ALL.

    default:\
    	:chlim#64:raflags#0:rltime#1800:rtime#0:retrans#0:\
    	:pinfoflags="la":vltime#2592000:pltime#604800:mtu#0:
    ef0:\
    	:addr="2001:db8:ffff:1000::":prefixlen#64:tc=default:

SEE ALSO
termcap(5), resolver(5), rtadvd(8), rtsol(8) Thomas Narten, Erik Nordmark, W. A. Simpson, Hesham Soliman, Neighbor Discovery for IP version 6 (IPv6), RFC 4861. Thomas Narten, Erik Nordmark, W. A. Simpson, Neighbor Discovery for IP version 6 (IPv6), RFC 2461 (obsoleted by RFC 4861). Richard Draves, Default Router Preferences and More-Specific Routes, draft-ietf-ipngwg-router-selection-xx.txt. J. Jeong, S. Park, L. Beloeil, S. Madanapalli, IPv6 Router Advertisement Options for DNS Configuration, RFC 6106.

HISTORY
The rtadvd(8) and the configuration file rtadvd.conf first appeared in WIDE Hydrangea IPv6 protocol stack kit.